#include <stdio.h>
#include <stdlib.h>
#define MAX 10000

int n;
static int x[MAX];
/***********************************************************
* FUNCTION NAME: sum
*
* DESCRIPTION:  sums the elements of x up to and not
*               including index k
*
* ARGUMENT LIST:
* Argument        Type   IO      Description
* ------------- -------- -- --------------------------------
* int           k         I limit index in x
* RETURN VALUE: int      sum of first k elements of x
*
* CHANGES: -
*************************************************************/

int sum(const int k)
{
    int i, sum = 0;
    for (i = 0; i < k; i++)
    {
// Uncomment the next 3 lines to get unique sums only
//        if (i < k - 1)
//        {
//            if (x[ i ] > x[ i + 1]) return n + 1;
//        }
        sum += x[ i ];
    }
    return sum;
}
/***********************************************************
* FUNCTION NAME: printX
*
* DESCRIPTION:  prints the contents of vector x up to index k
*           vector x contains a partition of n
*
* ARGUMENT LIST:
* Argument        Type   IO      Description
* ------------- -------- -- --------------------------------
* int           k
* RETURN VALUE: void
*
* CHANGES:
*************************************************************/
void printX(const int k)
{
    int i;
    for (i = 0; i < k; i++)
    {
        if (i) printf("+");
        printf(" %d ", x[ i ]);
    }
    printf("\n");
}
/***********************************************************
* FUNCTION NAME: part
*
* DESCRIPTION:  generates a partition of number k
*
* ARGUMENT LIST:
* Argument        Type   IO      Description
* ------------- -------- -- --------------------------------
* int k                   I  number for which to generate partition
* RETURN VALUE: void
*
* CHANGES: vector x
*************************************************************/
void part( const int k )
{
    static int val;
    int i;

    for (i = 1; i < n; i++)
    {
        x[k - 1] = i;
        val = sum(k);
        if (val <= n)
        {
            if (val == n)
                printX(k);
            else
                part(k + 1);
        }
    }
}

int main()
{
    do
    {
        printf("Number to split [ < %d ]: ", MAX);
        scanf("%d", &n);
    }
    while (n <=0 || n >=MAX);
    part(1);
    return 0;
}
